#! /bin/bash
# copyLa.sh
# Status /home/sfc250sm/XML/CopyEv.xml:
###############################################################
# <?xml version="1.0" encoding="iso-8859-1"?>
# <CopyLa>
#  <Status>
#    CopyLa_Ready 
#  </Status>
# </CopyEv>
###############################################################
# Inhalt Status-Tag:
# CopyLa_Ready			Start- und Reset-Wert (von GUI nach Beendigung zu setzen!)	
# CopyLa_Busy   		Kopiervorgang luft, warte auf Ergebnis
# CopyLa_NoUSB  		kein USB Stick gefunden (Abbruch)
# CopyLa_MoreDev 		zuviele USB-Partitionen gefunden (Abbruch)
# CopyLa_NoDataDir 		kein Verzeichnis /FIRMWARE/local/ auf Stick gefunden (Abbruch)
# CopyLa_ErrorVersionFile	kein Versionsfile V_xxxx.txt gefunden (Abbruch)
# CopyLa_ErrorVersionID		Versionsnummer auf Stick kleiner als aktuelle  (Abbruch)
# CopyLa_ErrorCSVListing	Anzahl der Sprachdateien nicht vollstndig oder neue Sprachen auf Stick (Abbruch)
# CopyLa_ErrorEmptyFile		leere Sprachdateien (*.csv) gefunden (Abbruch)
# CopyLa_Success		Update Sprachen erfolgreich -> Rcksetzen auf CopyLaReady	
###############################################################
EC=0

# XML-Datei erstellen und Zugriffsrechte anpassen
echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa> \n <Status>\n  CopyLa_busy \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
chmod 664 /home/sfc250sm/XML/CopyLa.xml
chgrp www-data /home/sfc250sm/XML/CopyLa.xml

# Variablen
dir=$(awk '/media/ { print $2}' /etc/mtab)		# in /media/ eingebundene Geräte

# Fehlerbehandlung kein USB-Stick erkannt
if [ "$dir" == "" ]
then
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_NoUSB \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo "Kein USB-Stick!"
	exit 1
fi

# Fehlerbehandlung mehrere USB-Sticks erkannt
if [ "`echo $dir | wc -w`" != "1" ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_MoreDev \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Mehrere USB-Devices in /media eingebunden!"
	exit 2
fi

# Fehlerbehandlung Pfad erkannt
datadir=$dir/FIRMWARE/local
#echo $datadir
if [ ! -d "$datadir" ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_NoDataDir \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Kein Sprachupdate auf USB-Stick vorhanden!"
	exit 3
fi

# Fehlerbehandlung Versions-Datei erkannt
versionFileNew=$(ls $datadir/V_*.txt)
#echo $versionFileNew
if [ "`echo $versionFileNew | wc -w`" != "1" ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_ErrorVersionFile \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Fehler Versionsdatei!"
	exit 4
fi

# Fehlerbehandlung Versionen Vergleich
versionFileCurr=$(ls /home/sfc250sm/WebServer/local/V_*.txt)
#echo $versionFileCurr
dateiCurr=${versionFileCurr##*/}
dateiNew=${versionFileNew##*/}
versionCurr=${dateiCurr//[^0-9]}
versionNew=${dateiNew//[^0-9]}
#echo $versionCurr
#echo $versionNew
if [ $versionCurr -gt $versionNew ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_ErrorVersionID \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Versionsnummer älter!"
	exit 5
fi

# Fehlerbehandlung Sprachdateien Vergleich
workingDir=$(pwd)
cd $datadir
dirCSVNew=$(ls *.csv)
cd /home/sfc250sm/WebServer/local/
dirCSVCurr=$(ls *.csv)
cd $workingDir
#echo $dirCSVNew
#echo $dirCSVCurr
if [ "$dirCSVNew" != "$dirCSVCurr" ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_ErrorCSVListing \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Sprachdateien ungleich!"
	exit 6
fi

# Fehlerbehandlung Sprachdateien leer
findZeroFile=$(find $datadir/*.csv -size 0 -ls | wc -l)
#echo $findZeroFile
if [ $findZeroFile != 0 ]
then 
    echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_ErrorEmptyFile \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Sprachdateie(n) leer!"
	exit 7
fi

#Prüfung ok -> Copy data
rm /home/sfc250sm/WebServer/local/V_*.txt
cp $datadir/* /home/sfc250sm/WebServer/local/
echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyLa>\n <Status>\n  CopyLa_Success \n </Status>\n</CopyEv>" > /home/sfc250sm/XML/CopyLa.xml
	echo -e "Sprachupdate erfolgreich!"

chmod 664 /home/sfc250sm/WebServer/local/*
#chown www-data /home/sfc250sm/WebServer/local/*
chgrp www-data /home/sfc250sm/WebServer/local/*

#echo $EC
exit $EC
