#!/bin/bash
#
# Aufruf mit Kommandozeilenparameter
# DelEv.sh Events	-> lösche Fehlerevents
# DelEv.sh Tracks	-> lösche Trackingdaten
#
###################################################
# XML Tag   #               Werte                 #
###################################################
#  Status   #    busy   #   error    #    ready   #
###################################################
#           #    init   #   InvPar   #            #
#  Message  #           #            # Successful #
#           #  Removing #   DelErr   #            #
###################################################

# XML-Datei erstellen und Zugriffsrechte anpassen
echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  busy\n </Status>\n <Message>\n  Init\n </Message>\n <Total>\n  0\n </Total>\n <Aktuell>\n  0\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml
chmod 664 /home/sfc250sm/XML/CopyEv.xml
chgrp www-data /home/sfc250sm/XML/CopyEv.xml

# korrekten Programmaufruf testen
if [ "$1" != "Events" -a "$1" != "Tracks" ]
	then echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  error\n </Status>\n <Message>\n  InvPar\n </Message>\n <Total>\n  $totalfiles\n </Total>\n <Aktuell>\n  0\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml
	echo "ung\0374ltiger Parameter: \"$1\""
	exit 6
fi

# Variablen
#dir=$(awk '/media/ { print $2}' /etc/mtab)		# in /media/ eingebundene Geräte
#datum=$(date +%y%m%d_%H%M%S)					# aktuelles Datum und Uhrzeit
if [ "$1" == "Events" ]
	then sourcedir=/home/sfc250sm/Events					# Quellverzeichnis für Eventdaten
	totalfiles=`find ${sourcedir}* -type f -name '*.xml' | wc -l`		# Anzahl der Dateien bestimmen
	else sourcedir=/home/sfc250sm/trackIrms					# Quellverzeichnis für Trackdaten
	totalfiles=`find ${sourcedir}* -type f -name '*.csv' | wc -l`		# Anzahl der Dateien bestimmen
        echo resetRMS >> /home/sfc250sm/XML/tmp/Comin				# Reset aktuelles RMS-File
        echo resetRMS >> /home/sfc250sm/XML/tmp/Comin1				# Reset aktuelles RMS-File
        echo resetRMS >> /home/sfc250sm/XML/tmp/Comin2				# Reset aktuelles RMS-File
fi

echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  busy\n </Status>\n <Message>\n  Removing\n </Message>\n <Total>\n  $totalfiles\n </Total>\n <Aktuell>\n  0\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml

if [ "$1" == "Events" ]
	then mv /home/sfc250sm/sfclog/uilog /home/sfc250sm/sfclog/uilogx
	mkdir /home/sfc250sm/sfclog/uilog
	chmod 664 /home/sfc250sm/sfclog/uilog
	chgrp www-data /home/sfc250sm/sfclog/uilog
	rm -r /home/sfc250sm/sfclog/uilogx &
	mv /home/sfc250sm/sfclog/uilog1 /home/sfc250sm/sfclog/uilogy
	mkdir /home/sfc250sm/sfclog/uilog1
	chmod 664 /home/sfc250sm/sfclog/uilog1
	chgrp www-data /home/sfc250sm/sfclog/uilog1
	rm -r /home/sfc250sm/sfclog/uilogy &
	mv /home/sfc250sm/sfclog/uilog2 /home/sfc250sm/sfclog/uilogz
	mkdir /home/sfc250sm/sfclog/uilog2
	chmod 664 /home/sfc250sm/sfclog/uilog2
	chgrp www-data /home/sfc250sm/sfclog/uilog2
	rm -r /home/sfc250sm/sfclog/uilogz &
	rm -r /home/sfc250sm/sfclog/eventlog.txt.* &
fi

if [ "$1" == "Events" ]
	then rm -r ${sourcedir}*/*.xml &
	else rm -r ${sourcedir}*/*.csv &
fi

while [ -n "`ps -p $! | grep $!`" ]
do
	if [ "$1" == "Events" ]
	then currfiles=`find ${sourcedir}* -type f -name '*.xml' | wc -l`
	else currfiles=`find ${sourcedir}* -type f -name '*.csv' | wc -l`
	fi
	echo $currfiles/$totalfiles
	echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  busy\n </Status>\n <Message>\n  Removing\n </Message>\n <Total>\n  $totalfiles\n </Total>\n <Aktuell>\n  $currfiles\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml
done

if [ "$1" == "Events" ]
	then currfiles=`find ${sourcedir}* -type f -name '*.xml' | wc -l`
	else currfiles=`find ${sourcedir}* -type f -name '*.csv' | wc -l`
fi
if [ $currfiles != "0" ]
	then echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  error\n </Status>\n <Message>\n  DelErr\n </Message>\n <Total>\n  $totalfiles\n </Total>\n <Aktuell>\n  $currfiles\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml
	exit 4
fi

echo -e "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<CopyEv>\n <Status>\n  ready\n </Status>\n <Message>\n  Successful\n </Message>\n <Total>\n  $totalfiles\n </Total>\n <Aktuell>\n  $currfiles\n </Aktuell>\n</CopyEv>" > /home/sfc250sm/XML/CopyEv.xml
