#!/bin/bash
ModemDevice=/dev/ttyACM0
ModemRxFile=/home/sfc250sm/XML/tmp/ModemRx

echo "starting Modemini.sh"


#Schnittstelle Konfigurieren
stty -F $ModemDevice 115200 ignbrk -brkint -icrnl -imaxbel -opost -onlcr -isig -icanon -iexten -echo -echoe -echok -echoctl -echoke

#Leseprozes starten
cat $ModemDevice > $ModemRxFile &
echo > $ModemRxFile
echo -e "AT\r" > $ModemDevice
sleep 1
echo > $ModemRxFile

n=0

while [ $n -lt 5 ]
do

	echo "reading Modem version"

	#ModemVersion abfragen
	echo > $ModemRxFile
	echo -e "AT+CGMR\r" > $ModemDevice
	sleep 1
	#Antwort lesen
	#RHL769x.2.27.183100.201809071813.x7120m_3
	#RHL85xx.5.5.17.0.201506151655.x6250_1
	ModemRxStr=$( grep -a 'RHL' $ModemRxFile | cut -f1 -d'.' )
	
	echo "Version: ""$ModemRxStr"	

	  case "$ModemRxStr" in
		"RHL769x")
			echo "HL7692 detected"
			#USB-Mode abfragen
			echo > $ModemRxFile
			echo -e "AT+KUSBCOMP?\r" > $ModemDevice
			sleep 1
			ModemRxStr=$( grep -a '+KUSBCOMP:' $ModemRxFile | cut -f2 -d' ' | cut -b1)
			echo "USB Mode: ""$ModemRxStr"	
			if [ $ModemRxStr -eq 1 ]
			then
				n=5
				echo "HL7692 KUSBCOMP=1; ok;"
			else
				echo "HL7692 KUSBCOMP!=1; must be 1;"
				echo -e "AT+KUSBCOMP=1\r" > $ModemDevice
				sleep 1
				if [ ! -e /sys/class/gpio/gpio58 ]
				then
					echo '58'>/sys/class/gpio/export
				fi
				echo out>/sys/class/gpio/gpio58/direction
				echo '1'>/sys/class/gpio/gpio58/value
				sleep 1
				echo '0'>/sys/class/gpio/gpio58/value
				#warten bis Devicenode in /dev angelegt ist
				while [ ! -e /dev/ttyACM3 ]
				do
       		sleep 1
				done
				n=$(($n + 1))
				kill -9 $!
				rm $ModemRxFile
				#Leseprozes starten
				cat $ModemDevice > $ModemRxFile &
				echo > $ModemRxFile
				echo -e "AT\r" > $ModemDevice
				sleep 1
				echo > $ModemRxFile
			fi
			;;
		"RHL85xx")
			echo "HL8548 detected"
			n=5
			break
			;;
		*)
			echo "could not detect Modem"
			n=$(($n + 1))
			sleep 1
			;;
	  esac

done

kill -9 $!
rm $ModemRxFile
echo terminating

exit 0
