// JavaScript Document

//****************************************************
//*******   Slider und Button Definitionen     *******
//****************************************************

$(document).on("pagecreate", "#page1", function(){

    //EXAMPLE 1 - change highlight color based on slider value
    HighlightColor($("#theSlider1"));
    $("#theSlider1").on("change", function(){
        HighlightColor($(this));
    });
    function HighlightColor(slider){
        var theVal = slider.val();
        var color = "#0DB8B5";
        if (theVal < 20){
            color = "#D92727";
        } else if (theVal < 40){
            color = "#FC8F12";
        } else if (theVal < 60){
            color = "#FFE433";
        } else if (theVal < 80){
            color = "#6FCC43";
        }        
        slider.closest(".ui-slider").find(".ui-slider-bg").css("background-color", color);        
    }
    
    //EXAMPLE 2 - add labled color scale to slider track
    var colorback  = '<div class="sliderBackColor green">Low</div>';
        colorback += '<div class="sliderBackColor orange">Medium</div>';
        colorback += '<div class="sliderBackColor red">High</div>';
    
    $("#example2 .ui-slider-track").prepend(colorback);
    
    //EXAMPLE 2a - add tick marks to slider track    
    var ticks  = '<div class="sliderTickmarks "><span>0%</span></div>';
        ticks += '<div class="sliderTickmarks "><span>25%</span></div>';
        ticks += '<div class="sliderTickmarks "><span>50%</span></div>';
        ticks += '<div class="sliderTickmarks "><span>75%</span></div>';
        ticks += '<div class="sliderTickmarks "><span>100%</span></div>';
    
    $("#example2a .ui-slider-track").prepend(ticks);
    
    //EXAMPLE 3 - change active handle's glow color
    GlowColor($("#theSlider3"));
    $("#theSlider3").on("change", function(){
        GlowColor($(this));
    }); 
    function GlowColor(slider){
        var theVal = slider.val();
        var glowClass = "glowRed";
        if (theVal < 25){
            glowClass = "glowGreen";
        } else if (theVal < 50){
            glowClass = "glowBlue";
        } else if (theVal < 75){
            glowClass = "glowYellow";
        }      
        slider.parents(".glow").removeClass("glowBlue glowYellow glowRed glowGreen").addClass(glowClass);    
    }
    
    //EXAMPLE 4 - value on handle
    $("#theSlider4").closest(".ui-slider").find(".ui-slider-handle").text($("#theSlider4").val());
    $("#theSlider4").on("change", function(){
        $(this).closest(".ui-slider").find(".ui-slider-handle").text($(this).val());
    });  
    
    //EXAMPLE 5 - multi-state flip switch
    var switchBack  = '<div id="sw1" class="switch5BackColor pos1">pos 1</div>';
        switchBack += '<div id="sw2" class="switch5BackColor pos2">pos 2</div>';
        switchBack += '<div id="sw3" class="switch5BackColor pos3">pos 3</div>';
        switchBack += '<div id="sw4" class="switch5BackColor pos4">pos 4</div>';
        switchBack += '<div id="sw5" class="switch5BackColor pos5">pos 5</div>';    
    
    $("#example5 .ui-slider-track").on('click', '.switch5BackColor', function(e){
        //make sure switch is in correct position
        var val = 1;
        if ($(this).hasClass("pos2")) {val = 2;}
        if ($(this).hasClass("pos3")) {val = 3;}
        if ($(this).hasClass("pos4")) {val = 4;}
        if ($(this).hasClass("pos5")) {val = 5;}
        $("#theSlider5").val(val).slider( "refresh" ).trigger("change");
        return false;
    });
    
    $("#example5 .ui-slider-track").prepend(switchBack);
    PositionSwitchHandle($("#theSlider5"));
    $("#theSlider5").on("change", function(){
        PositionSwitchHandle($(this));
    });
    
    
});


$(document).on( "pagecontainershow", function(){
    PositionSwitchHandle($("#theSlider5"));     
});
$(window).on("resize orientationchange", function(){
    PositionSwitchHandle($("#theSlider5"));
});

function PositionSwitchHandle(slider){
    var $handle = slider.closest(".ui-slider").find(".ui-slider-track");
    var handleWidth = $handle.width();
    var mgPct = (30 * 100) / handleWidth; //half thumb handle in pct of track
    var theVal = parseInt(slider.val());
    var margLeft = -mgPct;
    var glowClass = "pos3glow";
    var theText = "pos 3"
    if (theVal <= 1){
        margLeft = 10 - mgPct;
        glowClass = "pos1glow";
        theText = "pos 1"
    } else if (theVal == 2){
        margLeft = 5 - mgPct;
        glowClass = "pos2glow";
        theText = "pos 2"
    } else if (theVal == 4){
        margLeft = -5 - mgPct;
        glowClass = "pos4glow";
        theText = "pos 4"
    } else if (theVal >= 5){
        margLeft = -10 - mgPct;
        glowClass = "pos5glow";
        theText = "pos 5"
    }
    slider.closest(".ui-slider").find(".ui-slider-handle").css("marginLeft", margLeft + "%").text(theText);  
    slider.parents(".glow").removeClass("pos1glow pos2glow pos3glow pos4glow pos5glow").addClass(glowClass);
}




//****************************************************
//*****   Slider und Button Definitionen   ENDE  *****
//****************************************************
